<template>
	<div
		v-if="hasAnyAvailableItems"
		:id="id"
		:style="{
			'--bg-color-small': backgroundColorMobile || '#fff',
			'--bg-color-medium': backgroundColorDesktop || '#fff',
			'--heading-bg-color-small': headingBackgroundColorMobile || '#fff',
			'--heading-bg-color-medium': headingBackgroundColorDesktop || '#fff',
			'--number-of-columns': numberOfColumns,
		}"
		:class="[$style.block, $style.backgroundColor, { [$style.hasFourColumns]: numberOfColumns == 4 }]"
	>
		<div :class="[$style.header, $style.headingBackgroundColor]">
			<h2 :class="[$style.heading, { [$style.displayBelowMedium]: headingDesktop }]">{{ headingMobile }}</h2>
			<h2 v-if="headingDesktop" :class="[$style.heading, $style.displayAboveMedium]">{{ headingDesktop }}</h2>
		</div>
		<div :class="$style.productsWrapper">
			<BlockAddToCartV2Product
				v-for="product in productsNormalized"
				:key="product.sku"
				:title-mobile="product.titleMobile"
				:title-desktop="product.titleDesktop"
				:description="product.description"
				:image-mobile="product.imageMobile"
				:image="product.image"
				:discount="product.discount"
				:show-affirm="product.enableAffirm"
				:cta-text="product.ctaText"
				:cta-link="product.ctaLink"
				:reviews-link="product.reviewsLink"
				:ship-message="product.shipMessage"
				:powerreviews-page-id="product.powerreviewsPageId"
				:should-make-space-for-reviews="shouldMakeSpaceForReviews"
				:has-reviews-and-ship-message="hasReviewsAndShipMessage"
				:product-or-bundle="product.productOrBundle"
				:critical="critical"
				:watermark-image="product.watermarkImageMobile"
				:watermark-images="product.watermarkImageDesktop"
				:watermark-height="product.watermarkHeight || 50"
				:watermark-width="product.watermarkWidth || 100"
				:watermark-opacity="product.watermarkOpacity"
				:watermark-position="product.watermarkPosition"
			/>
		</div>
	</div>
</template>

<script>
import BlockAddToCartV2Product from '@components/block-add-to-cart-v2-product';

export default {
	components: { BlockAddToCartV2Product },

	props: {
		productsNormalized: {
			type: Array,
			default: () => [],
		},

		id: {
			type: String,
			default: null,
		},

		headingMobile: {
			type: String,
			required: true,
		},

		headingDesktop: {
			type: String,
			default: '',
		},

		backgroundColorMobile: {
			type: String,
			default: '',
		},

		backgroundColorDesktop: {
			type: String,
			default: '',
		},

		headingBackgroundColorMobile: {
			type: String,
			default: '',
		},

		headingBackgroundColorDesktop: {
			type: String,
			default: '',
		},

		items: {
			type: Array,
			required: true,
		},

		numberOfColumns: {
			type: [Number, String],
			default: 3,
		},

		critical: {
			type: Boolean,
			default: false,
		},

		hasAnyAvailableItems: {
			type: Boolean,
			default: true,
		},

		shouldMakeSpaceForReviews: {
			type: Boolean,
			default: false,
		},

		hasReviewsAndShipMessage: {
			type: Boolean,
			default: false,
		},
	},
	data() {
		return {};
	},
};
</script>

<style lang="scss" module>
@import '@design';

@mixin responsive-bg-colors($small-var, $medium-var) {
	background-color: var($small-var);

	@include above('medium') {
		background-color: var($medium-var);
	}
}

.block {
	overflow: hidden;
	white-space: pre-line;
}

.backgroundColor {
	@include responsive-bg-colors(--bg-color-small, --bg-color-medium);
}

.headingBackgroundColor {
	@include responsive-bg-colors(--heading-bg-color-small, --heading-bg-color-medium);
}

.header {
	padding: 5rem 5.2rem 5rem;
	margin: 0 0 3rem;

	@include above('medium') {
		padding: 5rem 5.2rem 4rem;
		margin: 0;
	}
}

.heading {
	@include use-text-style('heading-420');

	font-family: font-family('secondary');
	color: color('primary-300');
	text-align: center;

	@include above('medium') {
		@include use-text-style('heading-650');
	}
}

.displayBelowMedium {
	@include above('medium') {
		display: none;
	}
}

.displayAboveMedium {
	@include below('medium') {
		display: none;
	}
}

.productsWrapper {
	position: relative;
	display: grid;
	grid-template-columns: 1fr;
	gap: 5.5rem;
	width: 100%;
	padding: 0 2.8rem 4rem;

	@include above('medium') {
		grid-template-columns: repeat(var(--number-of-columns), 1fr);
		gap: 7rem 4rem;
		padding: 0 4rem 5rem;
	}

	@include above('large') {
		gap: 7rem 7rem;
		padding: 0 10rem 5rem;
	}

	@include above('xlarge') {
		gap: 7rem 10rem;
		padding: 0 14rem 5rem;
	}

	.hasFourColumns & {
		@include above('medium') {
			grid-template-columns: repeat(3, 1fr);
		}

		@include above('xlarge') {
			grid-template-columns: repeat(var(--number-of-columns), 1fr);
			gap: 7rem 6.6667rem;
		}
	}
}
</style>
